<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8" />
<title>Turtle control</title>
<meta name="generator" content="jrweb" />
<link rel="stylesheet" href="main.css">
<script src="main.js"></script>
<script>
/**
 * todo: show message and error
 */
function append_step(values) {
    steps = document.getElementById('steps');
    var _cnt = document.createElement('div');
    var _label = document.createElement('label');
    _label.innerHTML = 'Step';
    var _input = document.createElement('input');
    _input.setAttribute('id', 'steps[]');
    _input.setAttribute('name', 'steps[]');
    _input.setAttribute('type', 'text');
    _input.setAttribute('value', values);

    var _del = document.createElement('a');
    _del.innerHTML='-';
    _del.onclick = function(onclick) {
        steps.removeChild(_cnt);
    }

    _cnt.appendChild(_label);
    _cnt.appendChild(_input);
    _cnt.appendChild(_del);


    steps.appendChild(_cnt);
}

function my_callback(json) {
    var data = JSON.parse(json);

    // set current action
    actions = document.getElementById('animation');
    actions.value = data.current;
    console.log(data);

    // set possible actions
    var len = data.animations.length;
    actionlist = document.getElementById('actionlist');

    actionlist.innerHTML = ''
    for  (var i = 0; i < len; i++) {
        action = data.animations[i];
       var option = document.createElement('option');
        option.innerHTML = action
        option.value = action;
        if (action == data.current) {
            option.selected = 'selected';
        }
        actionlist.append(option);
    }

    // fill steps
    document.getElementById('steps').innerHTML='';
    len = data.steps.length;
    for (var i = 0; i < len; i++) {
        step = data.steps[i];
        append_step(step);
    }
}

function delete_action() {
    animation = document.getElementById('animation').value;

    if (confirm("Do you want to delete " + animation + "?") == true) {
        load_json('/createstep?function=delete&animation='+animation, my_callback);
    }
}


</script>
</head>
<body>
    <div class="maindiv">
        <div class="headdiv">
        <center>Turtle edit</center>
        </div>
        <hr/>
        <div class="linkright"><a href="/">Back to Control</a></div>
        <form id="form" action="createstep" method="GET">
            <label for="animation">Current Action</label>
            <input type="hidden" name="function" value="create" />
            <input name="animation" id="animation" value="stand" onchange="load_json('/createstep?animation='+this.value, my_callback);" />
            <label for="actionlist">Select existing</label>
            <select id="actionlist" onchange="load_json('/createstep?animation='+this.value, my_callback);">
            </select>
            <center><span style="font-size:small">
            Values:<br>
            Front-Right, Front-Left, Back-Right, Back-Left<br>
            negative numbers turn clockwise
            </span></center>
            <hr>
            <div class="linkright"><a onclick="append_step('0.0,0.0,0.0,0.0')">+</a></div>
            <div id="steps"></div>
            <div class="linkright"><a onclick="append_step('0.0,0.0,0.0,0.0')">+</a></div>
            <center><input type="submit" /> <button onclick="delete_action()">Delete</button></center>
        </form>
        <div class="cloud" id="names">
        </div>
    </div>
    <script>
        // prepare form for loading via ajax
        prepare_form(document.getElementById("form"), my_callback);
        // load form data
        load_json('/createstep', my_callback);
    </script>
</body>
</html>
